#property indicator_chart_window

extern int box = 100, revers = 3, width = 1;
extern color Krestik = Blue, Nolik = Red, Border = Aqua;
int index, m, i;
double start_price[], last_price[], pr_h, pr_l, pbox;
string name, XO;
//+------------------------------------------------------------------+
void init()
  {
  if(box <= 0) box = 1;
  if(revers <= 0) revers = 1;
  if(width <= 0) width = 1;
  pbox = box*Point;
  }
//+------------------------------------------------------------------+
void podgotovka()
  { 
  for(i=ObjectsTotal()-1;i>=0;i--)
    {
    if(StringSubstr(ObjectName(i), 0, StringLen(WindowExpertName())) == WindowExpertName())
    ObjectDelete(ObjectName(i));
    }
  
  ArrayResize(start_price,0);
  ArrayResize(last_price,0);
  
  setasseries(false);
  }
//+------------------------------------------------------------------+
int Resize()
  {
  ArrayResize(start_price,ArrayRange(start_price,0)+1);
  ArrayResize(last_price,ArrayRange(last_price,0)+1);
  return(ArrayRange(start_price,0)-1);
  }
//+------------------------------------------------------------------+
void start()
  { 
  if(Bars-1 == IndicatorCounted()) return(0);
  else podgotovka();
 
  for(index = Bars-1; index > 0; index--)
    {
    pr_h = NormalizeDouble(MathFloor(High[index]/pbox)*pbox,Digits);
    pr_l = NormalizeDouble(MathCeil (Low[index] /pbox)*pbox,Digits);
    
    if(ArrayRange(start_price,0) == 0)
      {
      m = Resize();
      start_price[m] = NormalizeDouble(pr_l + pbox,Digits);
      last_price[m] = pr_l;
      XO = " ";
      continue;
      }
    
    if(XO == " ")
      {
      if(pr_l <= NormalizeDouble(last_price[m]-pbox,Digits))
        {
        last_price[m] = pr_l;
        continue;
        }
        
      if(pr_h >= NormalizeDouble(last_price[m]+pbox*revers,Digits))
        {
        m = Resize();
        start_price[m] = NormalizeDouble(last_price[m-1]+pbox,Digits);
        last_price[m] = pr_h;
        XO = " ";
        continue;
        }
      }
    
    if(XO == " ")
      {
      if(pr_h >= NormalizeDouble(last_price[m] + pbox,Digits))
        {
        last_price[m] = pr_h;
        continue;
        }
        
      if(pr_l <= NormalizeDouble(last_price[m] - pbox*revers,Digits))
        {
        m = Resize();
        start_price[m] = NormalizeDouble(last_price[m-1]-pbox,Digits);
        last_price[m] = pr_l;
        XO = " ";
        continue;
        }
      }
    }
  
  setasseries(true);
  
  for(; m >= 0; m--) create();  
  
  Comment("X - dOrsey","   box - ", box,"   revers - ", revers);
  }
//+------------------------------------------------------------------+
void setasseries(bool x)
  {
  ArraySetAsSeries(start_price,x);
  ArraySetAsSeries(last_price,x);
  }
//+------------------------------------------------------------------+
void create()
  {
  static color c;
  i = m + 1; int t = i*width - width +1;
  
  if(t+width*2 > Bars)return;
  
  if(start_price[m] == last_price[m]){if(c == Nolik)c = Krestik; else c = Nolik;}
  else {if(start_price[m] > last_price[m]) c = Nolik; else c = Krestik;}
  
  pr_h = NormalizeDouble(MathMax(start_price[m], last_price[m]),Digits);
  pr_l = NormalizeDouble(MathMin(start_price[m], last_price[m]),Digits);
  
  name = WindowExpertName()+" "+DoubleToStr(i,0);
  
  double prh = NormalizeDouble(pr_h+pbox/2,Digits+1);
  double prl = NormalizeDouble(pr_l-pbox/2,Digits+1);
  
  ObjectCreate(name,OBJ_RECTANGLE,0,Time[t],prh,Time[t+width],prl);
  ObjectSet(name,OBJPROP_COLOR,c);
  
  for( ; pr_l <= pr_h; pr_l = NormalizeDouble(pr_l + pbox,Digits))
    {
    prh = NormalizeDouble(pr_l+pbox/2,Digits+1); prl = NormalizeDouble(pr_l-pbox/2,Digits+1);
    ObjectCreate(name+" "+DoubleToStr(pr_l,Digits),OBJ_RECTANGLE,0,Time[t],prl,Time[t+width],prh);
    ObjectSet(name+" "+DoubleToStr(pr_l,Digits), OBJPROP_COLOR, Border);
    ObjectSet(name+" "+DoubleToStr(pr_l,Digits), OBJPROP_BACK, false);
    }
  }
//+------------------------------------------------------------------+
 void deinit()
  {
  podgotovka();
  Comment("");
  }